<edit file>
$boarddir/index.php
</edit file>

<search for>
* Software Version:           SMF 1.0.12                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
$forum_version = 'SMF 1.0.12';
</search for>

<replace>
$forum_version = 'SMF 1.0.13';
</replace>

<search for>
// Determine if this is should be using WAP, WAP2, or imode.
</search for>

<replace>
// Seed the random generator for PHP < 4.2.0.
if (@version_compare(PHP_VERSION, '4.2.0') == -1)
{
	if (empty($modSettings['rand_seed']))
	{
		$modSettings['rand_seed'] = microtime() * 1000000;
		updateSettings(array('rand_seed' => $modSettings['rand_seed']));
	}
	$seed = ($modSettings['rand_seed'] + ((double) microtime() * 1000003)) & 0x7fffffff;
	srand($seed);
	// Change the seed?
	if (rand(1, 250) == 69)
		updateSettings(array('rand_seed' => rand()));
}

// Determine if this is should be using WAP, WAP2, or imode.
</replace>


<edit file>
$sourcedir/Calendar.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
	if (!isset($board))
		fatal_lang_error('calendar38', false);
	if (!isset($topic))
		fatal_lang_error('calendar39', false);
</search for>

<replace>
	if (empty($board))
		fatal_lang_error('calendar38', false);
	if (empty($topic))
		fatal_lang_error('calendar39', false);
</replace>


<edit file>
$sourcedir/Karma.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
	// Figure out where to go back to.... the topic?
	if (isset($topic))
</search for>

<replace>
	// Figure out where to go back to.... the topic?
	if (!empty($topic))
</replace>


<edit file>
$sourcedir/ManageBoards.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
				db_query("
					INSERT IGNORE INTO {$db_prefix}board_permissions
						(ID_BOARD, ID_GROUP, permission, addDeny)
					VALUES
						(" . implode('), (', $boardPerms) . ")", __FILE__, __LINE__);
</search for>

<replace>
				if (!empty($boardPerms))
					db_query("
						INSERT IGNORE INTO {$db_prefix}board_permissions
							(ID_BOARD, ID_GROUP, permission, addDeny)
						VALUES
							(" . implode('), (', $boardPerms) . ")", __FILE__, __LINE__);
</replace>


<edit file>
$sourcedir/ManageMembers.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
				'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['display_name'] . '</a>'
</search for>

<replace>
				'link' => empty($row['ID_MEMBER']) ? $row['display_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['display_name'] . '</a>'
</replace>


<edit file>
$sourcedir/Post.php
</edit file>

<search for>
* Software Version:           SMF 1.0.12                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
	if (isset($topic))
		getTopic();
</search for>

<replace>
	if (!empty($topic))
		getTopic();
</replace>

<search for>
		if (isset($topic) && !isset($_REQUEST['msg']))
			fatal_lang_error(1, false);
</search for>

<replace>
		if (!empty($topic) && !isset($_REQUEST['msg']))
			fatal_lang_error(1, false);
</replace>

<edit file>
$sourcedir/Profile.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
		if (!empty($_POST['dateRegistered']) && allowedTo('moderate_forum'))
</search for>

<replace>
		if (!empty($_POST['dateRegistered']) && allowedTo('admin_forum'))
</replace>


<edit file>
$sourcedir/QueryString.php
</edit file>

<search for>
* Software Version:           SMF 1.0.12                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
		if (get_magic_quotes_gpc() != 0)
			$_GET = stripslashes__recursive($_GET);
</search for>

<replace>
		if (@get_magic_quotes_gpc() != 0)
			$_GET = stripslashes__recursive($_GET);
</replace>

<search for>
	if (get_magic_quotes_gpc() == 0)
</search for>

<replace>
	if (@get_magic_quotes_gpc() == 0)
</replace>

<search for>
		// Now make sure the online log gets the right number.
		$_GET['topic'] = $topic;
	}
</search for>

<replace>
		// Now make sure the online log gets the right number.
		$_GET['topic'] = $topic;
	}
	else
		$topic = 0;
</replace>


<edit file>
$sourcedir/Security.php
</edit file>

<search for>
* Software Version:           SMF 1.0.10                                          *
</search for>

<replace>
* Software Version:           SMF 1.0.13                                          *
</replace>

<search for>
	// Load the Login template and language file.
	loadTemplate('Login');
	loadLanguage('Login');
</search for>

<replace>
	// Load the Login template and language file.
	loadLanguage('Login');

	// Are we in wireless mode?
	if (WIRELESS)
		$context['sub_template'] = WIRELESS_PROTOCOL . '_login';
	else
	{
		loadTemplate('Login');
		$context['sub_template'] = 'kick_guest';
	}
</replace>


<edit file>
$sourcedir/Subs-Package.php
</edit file>

<search for>
	if ($crc['crc32'] != crc32($data))
</search for>

<replace>
	if ($crc['crc32'] != smf_crc32($data))
</replace>

<search for>
		fclose($this->connection);

		return true;
	}
}
</search for>

<replace>
		fclose($this->connection);

		return true;
	}
}

// crc32 doesn't work as expected on 64-bit functions - make our own.
// http://www.php.net/crc32#79567
if (!function_exists('smf_crc32'))
{
	function smf_crc32($number)
	{
		$crc = crc32($number);
	
		if($crc & 0x80000000){
			$crc ^= 0xffffffff;
			$crc += 1;
			$crc = -$crc;
		}
	
		return $crc;
	} 
}
</replace>